
if (!window['Smart']) {
	window['Smart'] = { RenderMode: 'manual' };
}
else {
	window['Smart'].RenderMode = 'manual';
}
import './../source/modules/smart.pivottable';

import { __decorate, __extends, __awaiter, __generator } from 'tslib';
import { EventEmitter, Output, Input, ElementRef, Directive, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';

var BaseElement = /** @class */ (function () {
    function BaseElement(ref) {
        this.onCreate = new EventEmitter();
        this.onReady = new EventEmitter();
        this.onAttach = new EventEmitter();
        this.onDetach = new EventEmitter();
        var that = this;
        this.nativeElement = ref.nativeElement;
        that.nativeElement.onAttached = function () {
            that.onAttach.emit(that.nativeElement);
        };
        that.nativeElement.onDetached = function () {
            that.onDetach.emit(that.nativeElement);
        };
    }
    BaseElement.prototype.addEventListener = function (type, listener, options) {
        if (options === void 0) { options = false; }
        this.nativeElement.addEventListener(type, listener, options);
    };
    BaseElement.prototype.removeEventListener = function (type, listener, options) {
        if (options === void 0) { options = false; }
        this.nativeElement.removeEventListener(type, listener, options);
    };
    BaseElement.prototype.dispatchEvent = function (event) {
        return this.nativeElement.dispatchEvent(event);
    };
    BaseElement.prototype.blur = function () {
        this.nativeElement.blur();
    };
    BaseElement.prototype.click = function () {
        this.nativeElement.click();
    };
    BaseElement.prototype.focus = function (options) {
        this.nativeElement.focus(options);
    };
    Object.defineProperty(BaseElement.prototype, "locale", {
        /** @description Sets or gets the language. Used in conjunction with the property messages.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.locale : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.locale = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "localizeFormatFunction", {
        /** @description Callback used to customize the format of the messages that are returned from the Localization Module. */
        get: function () {
            return this.nativeElement ? this.nativeElement.localizeFormatFunction : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.localizeFormatFunction = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "messages", {
        /** @description Sets or gets an object specifying strings used in the widget that can be localized. Used in conjunction with the property locale.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.messages : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.messages = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "rightToLeft", {
        /** @description Sets or gets the value indicating whether the element is aligned to support locales using right-to-left fonts. */
        get: function () {
            return this.nativeElement ? this.nativeElement.rightToLeft : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rightToLeft = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "theme", {
        /** @description Determines the theme. Theme defines the look of the element */
        get: function () {
            return this.nativeElement ? this.nativeElement.theme : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.theme = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Output()
    ], BaseElement.prototype, "onCreate", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onReady", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onAttach", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onDetach", void 0);
    __decorate([
        Input()
    ], BaseElement.prototype, "locale", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "localizeFormatFunction", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "messages", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "rightToLeft", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "theme", null);
    return BaseElement;
}());
var Smart = window.Smart;

var PivotTableComponent = /** @class */ (function (_super) {
    __extends(PivotTableComponent, _super);
    function PivotTableComponent(ref) {
        var _this = _super.call(this, ref) || this;
        _this.eventHandlers = [];
        /** @description This event is triggered when a cell has been clicked.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	dataField, 	row)
        *   dataField - The data field of the cell's dynamic column.
        *   row - The data of the cell's row.
        */
        _this.onCellClick = new EventEmitter();
        /** @description This event is triggered when the selection is changed.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	type)
        *   type - The type of action that initiated the selection change. Possible types: 'programmatic', 'interaction', 'remove'.
        */
        _this.onChange = new EventEmitter();
        /** @description This event is triggered when a summary column header cell has been clicked.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	columnDefinition, 	dataField)
        *   columnDefinition - An object detailing the clicked dynamic column.
        *   dataField - The data field of the cell's original column.
        */
        _this.onColumnClick = new EventEmitter();
        /** @description This event is triggered when a row has been collapsed.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	record)
        *   record - The (aggregated) data of the collapsed row.
        */
        _this.onCollapse = new EventEmitter();
        /** @description This event is triggered when a total column has been collapsed.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	columnDefinition)
        *   columnDefinition - The definition of the collapsed total column.
        */
        _this.onCollapseTotalColumn = new EventEmitter();
        /** @description This event is triggered when a row has been expanded.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	record)
        *   record - The (aggregated) data of the expanded row.
        */
        _this.onExpand = new EventEmitter();
        /** @description This event is triggered when a total column has been expanded.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	columnDefinition)
        *   columnDefinition - The definition of the expanded total column.
        */
        _this.onExpandTotalColumn = new EventEmitter();
        /** @description This event is triggered when a filtering-related action is made.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	action, 	filters)
        *   action - The filtering action. Possible actions: 'add', 'remove'.
        *   filters - The added filters. Only when action is 'add'.
        */
        _this.onFilter = new EventEmitter();
        /** @description This event is triggered when a column header cell has been clicked.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	columns)
        *   columns - An array with information about the dynamic columns the PivotTable has been sorted by.
        */
        _this.onSort = new EventEmitter();
        _this.nativeElement = ref.nativeElement;
        return _this;
    }
    /** @description Creates the component on demand.
     * @param properties An optional object of properties, which will be added to the template binded ones.
     */
    PivotTableComponent.prototype.createComponent = function (properties) {
        if (properties === void 0) { properties = {}; }
        this.nativeElement = document.createElement('smart-pivot-table');
        for (var propertyName in properties) {
            this.nativeElement[propertyName] = properties[propertyName];
        }
        return this.nativeElement;
    };
    Object.defineProperty(PivotTableComponent.prototype, "animation", {
        /** @description Sets or gets the animation mode. Animation is disabled when the property is set to 'none' */
        get: function () {
            return this.nativeElement ? this.nativeElement.animation : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.animation = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "columnReorder", {
        /** @description Sets or gets whether the reordering of columns is enabled. */
        get: function () {
            return this.nativeElement ? this.nativeElement.columnReorder : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.columnReorder = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "columns", {
        /** @description Describes the columns of the PivotTable's original tabular data. Based on these settings and the data source, the actual columns of the PivotTable are dynamically generated. */
        get: function () {
            return this.nativeElement ? this.nativeElement.columns : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.columns = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "columnTotals", {
        /** @description Sets or gets whether to show total columns for each pivot data point. When enabled, all summary columns must have the same summary function set by which total columns are calculated. */
        get: function () {
            return this.nativeElement ? this.nativeElement.columnTotals : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.columnTotals = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "columnTotalsPosition", {
        /** @description Sets or gets the position of total columns (shown when columnTotals is enabled). */
        get: function () {
            return this.nativeElement ? this.nativeElement.columnTotalsPosition : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.columnTotalsPosition = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "conditionalFormatting", {
        /** @description Sets or gets details about conditional formatting to be applied to the PivotTable's cells. */
        get: function () {
            return this.nativeElement ? this.nativeElement.conditionalFormatting : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.conditionalFormatting = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "dataSource", {
        /** @description Determines the original tabular data source of the PivotTable. */
        get: function () {
            return this.nativeElement ? this.nativeElement.dataSource : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.dataSource = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "defaultSortByRowGroups", {
        /** @description Sets or gets whether the original tabular data sourse of the PivotTable will be pre-sorted based on columns with the rowGroup property (and their order). */
        get: function () {
            return this.nativeElement ? this.nativeElement.defaultSortByRowGroups : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.defaultSortByRowGroups = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "designer", {
        /** @description Sets or gets whether to display the PivotTable's designer alongside the table itself. The designer allows for configuring column settings and applying filtering. */
        get: function () {
            return this.nativeElement ? this.nativeElement.designer : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.designer = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "designerPosition", {
        /** @description Sets or gets the position of the PivotTable's designer (shown when designer is enabled). */
        get: function () {
            return this.nativeElement ? this.nativeElement.designerPosition : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.designerPosition = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "disabled", {
        /** @description Disables the interaction with the element. */
        get: function () {
            return this.nativeElement ? this.nativeElement.disabled : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.disabled = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "drillDown", {
        /** @description If enabled, shows the original tabular data that has been aggregated in a PivotTable summary cell when the cell is double-clicked or F2 is pressed. */
        get: function () {
            return this.nativeElement ? this.nativeElement.drillDown : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.drillDown = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "drillDownDataExport", {
        /** @description If set, shows an export button in the drill down dialog. */
        get: function () {
            return this.nativeElement ? this.nativeElement.drillDownDataExport : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.drillDownDataExport = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "drillDownDataExportName", {
        /** @description Sets or gets the drill down table export file name. */
        get: function () {
            return this.nativeElement ? this.nativeElement.drillDownDataExportName : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.drillDownDataExportName = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "drillDownTableInit", {
        /** @description Sets or gets whether sorting based on columns in classic row groups layout mode is enabled. */
        get: function () {
            return this.nativeElement ? this.nativeElement.drillDownTableInit : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.drillDownTableInit = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "drillDownCustomAction", {
        /** @description Sets or gets whether the PivotTable's column header is sticky/frozen. */
        get: function () {
            return this.nativeElement ? this.nativeElement.drillDownCustomAction : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.drillDownCustomAction = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "enableSortByRowGroups", {
        /** @description Sets or gets whether to show a Grand total row aggregating the data of all rows. */
        get: function () {
            return this.nativeElement ? this.nativeElement.enableSortByRowGroups : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.enableSortByRowGroups = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "freezeHeader", {
        /** @description Sets or gets the way row nesting (based on rowGroup columns) is displayed. */
        get: function () {
            return this.nativeElement ? this.nativeElement.freezeHeader : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.freezeHeader = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "getDefaultSummaryFunction", {
        /** @description Sets or gets whether to hide the tooltip that displays details when multiple summary cells with non-null values are selected. */
        get: function () {
            return this.nativeElement ? this.nativeElement.getDefaultSummaryFunction : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.getDefaultSummaryFunction = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "grandTotal", {
        /** @description Sets or gets whether to hide rows that contain only 0 or null values. Applicable only when there are rowGroup columns. */
        get: function () {
            return this.nativeElement ? this.nativeElement.grandTotal : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.grandTotal = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "groupLayout", {
        /** @description Sets or gets whether navigation with the keyboard is enabled in the PivotTable. */
        get: function () {
            return this.nativeElement ? this.nativeElement.groupLayout : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.groupLayout = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "hideCellSelectionTooltip", {
        /** @description Sets or gets the language. Used in conjunction with the property messages.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.hideCellSelectionTooltip : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.hideCellSelectionTooltip = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "hideEmptyRows", {
        /** @description Sets or gets an object specifying strings used in the element that can be localized. Used in conjunction with the property locale.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.hideEmptyRows : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.hideEmptyRows = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "keyboardNavigation", {
        /** @description Sets or gets what value is shown in cells that do not have aggregated data to display. By default (null), such cells are empty. */
        get: function () {
            return this.nativeElement ? this.nativeElement.keyboardNavigation : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.keyboardNavigation = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "locale", {
        /** @description Sets or gets the value indicating whether the element is aligned to support locales using right-to-left fonts. */
        get: function () {
            return this.nativeElement ? this.nativeElement.locale : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.locale = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "messages", {
        /** @description Sets or gets whether sorting by row (when a row group cell is clicked) is enabled. When columnTotals is also enabled, sorting is applied per "column group"; otherwise - for all columns. */
        get: function () {
            return this.nativeElement ? this.nativeElement.messages : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.messages = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "nullDefaultValue", {
        /** @description Sets or gets whether row summaries are displayed in the row headers. Example: Peterson(40) vs Peterson, when rowSummary is set to false. */
        get: function () {
            return this.nativeElement ? this.nativeElement.nullDefaultValue : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.nullDefaultValue = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "onCellRender", {
        /** @description Sets or gets whether to show row total columns for each summary column. */
        get: function () {
            return this.nativeElement ? this.nativeElement.onCellRender : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.onCellRender = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "onColumnRender", {
        /** @description Sets or gets the position of row total columns (shown when rowTotals is enabled). */
        get: function () {
            return this.nativeElement ? this.nativeElement.onColumnRender : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.onColumnRender = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "onInit", {
        /** @description Sets or gets whether row selection (via checkboxes) is enabled. */
        get: function () {
            return this.nativeElement ? this.nativeElement.onInit : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.onInit = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "rightToLeft", {
        /** @description Sets or gets the selection mode. Only applicable when selection is enabled. */
        get: function () {
            return this.nativeElement ? this.nativeElement.rightToLeft : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rightToLeft = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "rowSort", {
        /** @description Determines the sorting mode of the PivotTable. */
        get: function () {
            return this.nativeElement ? this.nativeElement.rowSort : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rowSort = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "rowSummary", {
        /** @description Determines the theme. Theme defines the look of the element */
        get: function () {
            return this.nativeElement ? this.nativeElement.rowSummary : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rowSummary = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "rowTotals", {
        /** @description Sets or gets whether the PivotTable's toolbar is shown. It contains two breadcrumb components that allow the modification of the row group and pivot columns, as well as the "Conditional Formatting" and "Fields" buttons that open a dialog with additional settings. */
        get: function () {
            return this.nativeElement ? this.nativeElement.rowTotals : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rowTotals = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "rowTotalsPosition", {
        /** @description Sets or gets whether when hovering a cell with truncated content, a tooltip with the full content will be shown. */
        get: function () {
            return this.nativeElement ? this.nativeElement.rowTotalsPosition : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rowTotalsPosition = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "selection", {
        /** @description undefined */
        get: function () {
            return this.nativeElement ? this.nativeElement.selection : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.selection = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "selectionMode", {
        /** @description undefined */
        get: function () {
            return this.nativeElement ? this.nativeElement.selectionMode : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.selectionMode = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "sortMode", {
        /** @description undefined */
        get: function () {
            return this.nativeElement ? this.nativeElement.sortMode : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.sortMode = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "theme", {
        /** @description undefined */
        get: function () {
            return this.nativeElement ? this.nativeElement.theme : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.theme = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "toolbar", {
        /** @description undefined */
        get: function () {
            return this.nativeElement ? this.nativeElement.toolbar : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.toolbar = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PivotTableComponent.prototype, "tooltip", {
        /** @description undefined */
        get: function () {
            return this.nativeElement ? this.nativeElement.tooltip : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.tooltip = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    /** @description Adds a filter to a specific column.
    * @param {string} dataField. The column's data field.
    * @param {any} filter. FilterGroup object.
    */
    PivotTableComponent.prototype.addFilter = function (dataField, filter) {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.addFilter(dataField, filter);
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.addFilter(dataField, filter);
            });
        }
    };
    /** @description Clears applied filters.
    */
    PivotTableComponent.prototype.clearFilters = function () {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.clearFilters();
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.clearFilters();
            });
        }
    };
    /** @description Clears selection.
    */
    PivotTableComponent.prototype.clearSelection = function () {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.clearSelection();
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.clearSelection();
            });
        }
    };
    /** @description Clears the PivotTable sorting.
    */
    PivotTableComponent.prototype.clearSort = function () {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.clearSort();
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.clearSort();
            });
        }
    };
    /** @description Collapses all rows (when multiple row groups are applied).
    */
    PivotTableComponent.prototype.collapseAllRows = function () {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.collapseAllRows();
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.collapseAllRows();
            });
        }
    };
    /** @description Collapses a row (when multiple row groups are applied).
    * @param {string | number} rowId. The id of the row to collapse. Can be retrieved from the <strong>rows</strong> collection.
    */
    PivotTableComponent.prototype.collapseRow = function (rowId) {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.collapseRow(rowId);
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.collapseRow(rowId);
            });
        }
    };
    /** @description Expands all rows (when multiple row groups are applied).
    */
    PivotTableComponent.prototype.expandAllRows = function () {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.expandAllRows();
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.expandAllRows();
            });
        }
    };
    /** @description Expands a row (when multiple row groups are applied).
    * @param {string | number} rowId. The id of the row to expand. Can be retrieved from the <strong>rows</strong> collection.
    */
    PivotTableComponent.prototype.expandRow = function (rowId) {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.expandRow(rowId);
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.expandRow(rowId);
            });
        }
    };
    /** @description Exports the PivotTable's data.
    * @param {string} dataFormat. The file format to export to. Supported formats: 'csv', 'html', 'json', 'pdf', 'tsv', 'xlsx', 'xml'.
    * @param {string} fileName?. The name of the file to export to
    * @param {Function} callback?. A callback function to pass the exported data to (if fileName is not provided)
    * @returns {any}
  */
    PivotTableComponent.prototype.exportData = function (dataFormat, fileName, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var getResultOnRender, result;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        getResultOnRender = function () {
                            return new Promise(function (resolve) {
                                _this.nativeElement.whenRendered(function () {
                                    var result = _this.nativeElement.exportData(dataFormat, fileName, callback);
                                    resolve(result);
                                });
                            });
                        };
                        return [4 /*yield*/, getResultOnRender()];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /** @description Returns the current dynamic pivot columns.
    * @returns {any}
  */
    PivotTableComponent.prototype.getDynamicColumns = function () {
        return __awaiter(this, void 0, void 0, function () {
            var getResultOnRender, result;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        getResultOnRender = function () {
                            return new Promise(function (resolve) {
                                _this.nativeElement.whenRendered(function () {
                                    var result = _this.nativeElement.getDynamicColumns();
                                    resolve(result);
                                });
                            });
                        };
                        return [4 /*yield*/, getResultOnRender()];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /** @description Returns an array of selected row ids (when selectionMode is 'many' or 'extended') or an array of selected cell details (when selectionMode is 'cell').
    * @returns {(string | number)[] | { dataField: string, rowId: string | number }[]}
  */
    PivotTableComponent.prototype.getSelection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var getResultOnRender, result;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        getResultOnRender = function () {
                            return new Promise(function (resolve) {
                                _this.nativeElement.whenRendered(function () {
                                    var result = _this.nativeElement.getSelection();
                                    resolve(result);
                                });
                            });
                        };
                        return [4 /*yield*/, getResultOnRender()];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /** @description Refreshes the PivotTable.
    */
    PivotTableComponent.prototype.refresh = function () {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.refresh();
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.refresh();
            });
        }
    };
    /** @description Removes filters applied to a specific column.
    * @param {string} dataField. The column's data field.
    */
    PivotTableComponent.prototype.removeFilter = function (dataField) {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.removeFilter(dataField);
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.removeFilter(dataField);
            });
        }
    };
    /** @description Selects one or more rows (when selectionMode is 'many' or 'extended') or a single cell (when selectionMode is 'cell' and the second argument is passed).
    * @param {string | number | (string | number)[]} rowId. The id of the row (or an array of row ids) to select (or of the cell's parent row when <strong>selectionMode</strong> is <em>'cell'</em>). Can be retrieved from the <strong>rows</strong> collection.
    * @param {string} dataField?. The dataField of the dynamic column (can be retrieved by calling <strong>getDynamicColumns</strong>) of the cell to select (only applicable when <strong>selectionMode</strong> is <em>'cell'</em>).
    */
    PivotTableComponent.prototype.select = function (rowId, dataField) {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.select(rowId, dataField);
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.select(rowId, dataField);
            });
        }
    };
    /** @description Sorts by a summary or group column.
    * @param {any} columnDefinition. The dynamic column's definition. Can be retrieved from the method <strong>getDynamicColumns</strong>.
    * @param {string} sortOrder?. Sort order. Possible values: 'asc' (ascending), 'desc' (descending), and null (removes sorting by column). If not provided, toggles the sorting.
    */
    PivotTableComponent.prototype.sortBy = function (columnDefinition, sortOrder) {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.sortBy(columnDefinition, sortOrder);
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.sortBy(columnDefinition, sortOrder);
            });
        }
    };
    /** @description Unselects one or more rows (when selectionMode is 'many' or 'extended') or a single cell (when selectionMode is 'cell' and the second argument is passed).
    * @param {string | number | (string | number)[]} rowId. The id of the row (or an array of row ids) to select (or of the cell's parent row when <strong>selectionMode</strong> is <em>'cell'</em>). Can be retrieved from the <strong>rows</strong> collection.
    * @param {string} dataField?. The dataField of the dynamic column (can be retrieved by calling <strong>getDynamicColumns</strong>) of the cell to select (only applicable when <strong>selectionMode</strong> is <em>'cell'</em>).
    */
    PivotTableComponent.prototype.unselect = function (rowId, dataField) {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.unselect(rowId, dataField);
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.unselect(rowId, dataField);
            });
        }
    };
    Object.defineProperty(PivotTableComponent.prototype, "isRendered", {
        get: function () {
            return this.nativeElement ? this.nativeElement.isRendered : false;
        },
        enumerable: true,
        configurable: true
    });
    PivotTableComponent.prototype.ngOnInit = function () {
    };
    PivotTableComponent.prototype.ngAfterViewInit = function () {
        var that = this;
        that.onCreate.emit(that.nativeElement);
        Smart.Render();
        this.nativeElement.classList.add('smart-angular');
        this.nativeElement.whenRendered(function () { that.onReady.emit(that.nativeElement); });
        this.listen();
    };
    PivotTableComponent.prototype.ngOnDestroy = function () {
        this.unlisten();
    };
    PivotTableComponent.prototype.ngOnChanges = function (changes) {
        if (this.nativeElement && this.nativeElement.isRendered) {
            for (var propName in changes) {
                if (changes.hasOwnProperty(propName)) {
                    this.nativeElement[propName] = changes[propName].currentValue;
                }
            }
        }
    };
    /** @description Add event listeners. */
    PivotTableComponent.prototype.listen = function () {
        var that = this;
        that.eventHandlers['cellClickHandler'] = function (event) { that.onCellClick.emit(event); };
        that.nativeElement.addEventListener('cellClick', that.eventHandlers['cellClickHandler']);
        that.eventHandlers['changeHandler'] = function (event) { that.onChange.emit(event); };
        that.nativeElement.addEventListener('change', that.eventHandlers['changeHandler']);
        that.eventHandlers['columnClickHandler'] = function (event) { that.onColumnClick.emit(event); };
        that.nativeElement.addEventListener('columnClick', that.eventHandlers['columnClickHandler']);
        that.eventHandlers['collapseHandler'] = function (event) { that.onCollapse.emit(event); };
        that.nativeElement.addEventListener('collapse', that.eventHandlers['collapseHandler']);
        that.eventHandlers['collapseTotalColumnHandler'] = function (event) { that.onCollapseTotalColumn.emit(event); };
        that.nativeElement.addEventListener('collapseTotalColumn', that.eventHandlers['collapseTotalColumnHandler']);
        that.eventHandlers['expandHandler'] = function (event) { that.onExpand.emit(event); };
        that.nativeElement.addEventListener('expand', that.eventHandlers['expandHandler']);
        that.eventHandlers['expandTotalColumnHandler'] = function (event) { that.onExpandTotalColumn.emit(event); };
        that.nativeElement.addEventListener('expandTotalColumn', that.eventHandlers['expandTotalColumnHandler']);
        that.eventHandlers['filterHandler'] = function (event) { that.onFilter.emit(event); };
        that.nativeElement.addEventListener('filter', that.eventHandlers['filterHandler']);
        that.eventHandlers['sortHandler'] = function (event) { that.onSort.emit(event); };
        that.nativeElement.addEventListener('sort', that.eventHandlers['sortHandler']);
    };
    /** @description Remove event listeners. */
    PivotTableComponent.prototype.unlisten = function () {
        var that = this;
        if (that.eventHandlers['cellClickHandler']) {
            that.nativeElement.removeEventListener('cellClick', that.eventHandlers['cellClickHandler']);
        }
        if (that.eventHandlers['changeHandler']) {
            that.nativeElement.removeEventListener('change', that.eventHandlers['changeHandler']);
        }
        if (that.eventHandlers['columnClickHandler']) {
            that.nativeElement.removeEventListener('columnClick', that.eventHandlers['columnClickHandler']);
        }
        if (that.eventHandlers['collapseHandler']) {
            that.nativeElement.removeEventListener('collapse', that.eventHandlers['collapseHandler']);
        }
        if (that.eventHandlers['collapseTotalColumnHandler']) {
            that.nativeElement.removeEventListener('collapseTotalColumn', that.eventHandlers['collapseTotalColumnHandler']);
        }
        if (that.eventHandlers['expandHandler']) {
            that.nativeElement.removeEventListener('expand', that.eventHandlers['expandHandler']);
        }
        if (that.eventHandlers['expandTotalColumnHandler']) {
            that.nativeElement.removeEventListener('expandTotalColumn', that.eventHandlers['expandTotalColumnHandler']);
        }
        if (that.eventHandlers['filterHandler']) {
            that.nativeElement.onfilterHandler = null;
        }
        if (that.eventHandlers['sortHandler']) {
            that.nativeElement.removeEventListener('sort', that.eventHandlers['sortHandler']);
        }
    };
    PivotTableComponent.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "animation", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "columnReorder", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "columns", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "columnTotals", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "columnTotalsPosition", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "conditionalFormatting", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "dataSource", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "defaultSortByRowGroups", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "designer", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "designerPosition", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "disabled", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "drillDown", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "drillDownDataExport", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "drillDownDataExportName", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "drillDownTableInit", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "drillDownCustomAction", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "enableSortByRowGroups", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "freezeHeader", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "getDefaultSummaryFunction", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "grandTotal", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "groupLayout", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "hideCellSelectionTooltip", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "hideEmptyRows", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "keyboardNavigation", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "locale", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "messages", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "nullDefaultValue", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "onCellRender", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "onColumnRender", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "onInit", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "rightToLeft", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "rowSort", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "rowSummary", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "rowTotals", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "rowTotalsPosition", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "selection", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "selectionMode", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "sortMode", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "theme", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "toolbar", null);
    __decorate([
        Input()
    ], PivotTableComponent.prototype, "tooltip", null);
    __decorate([
        Output()
    ], PivotTableComponent.prototype, "onCellClick", void 0);
    __decorate([
        Output()
    ], PivotTableComponent.prototype, "onChange", void 0);
    __decorate([
        Output()
    ], PivotTableComponent.prototype, "onColumnClick", void 0);
    __decorate([
        Output()
    ], PivotTableComponent.prototype, "onCollapse", void 0);
    __decorate([
        Output()
    ], PivotTableComponent.prototype, "onCollapseTotalColumn", void 0);
    __decorate([
        Output()
    ], PivotTableComponent.prototype, "onExpand", void 0);
    __decorate([
        Output()
    ], PivotTableComponent.prototype, "onExpandTotalColumn", void 0);
    __decorate([
        Output()
    ], PivotTableComponent.prototype, "onFilter", void 0);
    __decorate([
        Output()
    ], PivotTableComponent.prototype, "onSort", void 0);
    PivotTableComponent = __decorate([
        Directive({
            selector: 'smart-pivot-table, [smart-pivot-table]'
        })
    ], PivotTableComponent);
    return PivotTableComponent;
}(BaseElement));

var PivotTableModule = /** @class */ (function () {
    function PivotTableModule() {
    }
    PivotTableModule = __decorate([
        NgModule({
            declarations: [PivotTableComponent],
            schemas: [CUSTOM_ELEMENTS_SCHEMA],
            exports: [PivotTableComponent]
        })
    ], PivotTableModule);
    return PivotTableModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { PivotTableComponent, PivotTableModule, Smart, BaseElement as ɵa };
//# sourceMappingURL=smart-webcomponents-angular-pivottable.js.map
